package dev.shadowsoffire.apotheosis.village.fletching.arrows;

import net.minecraft.world.phys.Vec3;
import net.minecraft.world.phys.BlockHitResult;
import dev.shadowsoffire.apotheosis.village.VillageModule;
import net.minecraft.world.entity.Entity;
import net.minecraftforge.network.NetworkHooks;
import net.minecraft.network.protocol.game.ClientGamePacketListener;
import net.minecraft.network.protocol.Packet;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.LivingEntity;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.projectile.AbstractArrow;

public class ExplosiveArrowEntity extends AbstractArrow
{
    public ExplosiveArrowEntity(final EntityType<? extends AbstractArrow> t, final Level world) {
        super((EntityType)t, world);
    }
    
    public ExplosiveArrowEntity(final Level world) {
        super((EntityType)Apoth.Entities.EXPLOSIVE_ARROW.get(), world);
    }
    
    public ExplosiveArrowEntity(final LivingEntity shooter, final Level world) {
        super((EntityType)Apoth.Entities.EXPLOSIVE_ARROW.get(), shooter, world);
    }
    
    public ExplosiveArrowEntity(final Level world, final double x, final double y, final double z) {
        super((EntityType)Apoth.Entities.EXPLOSIVE_ARROW.get(), x, y, z, world);
    }
    
    protected ItemStack m_7941_() {
        return new ItemStack((ItemLike)Apoth.Items.EXPLOSIVE_ARROW.get());
    }
    
    public Packet<ClientGamePacketListener> m_5654_() {
        return (Packet<ClientGamePacketListener>)NetworkHooks.getEntitySpawningPacket((Entity)this);
    }
    
    protected void m_7761_(final LivingEntity living) {
        if (!this.m_9236_().f_46443_) {
            this.m_9236_().m_255391_((Entity)this, living.m_20185_(), living.m_20186_(), living.m_20189_(), 2.0f, false, VillageModule.expArrowMode);
            this.m_146870_();
        }
    }
    
    protected void m_8060_(final BlockHitResult res) {
        super.m_8060_(res);
        final Vec3 vec = res.m_82450_();
        if (!this.m_9236_().f_46443_) {
            this.m_9236_().m_255391_((Entity)this, vec.m_7096_(), vec.m_7098_(), vec.m_7094_(), 3.0f, false, VillageModule.expArrowMode);
            this.m_146870_();
        }
    }
}
